#LyX 2.3 created this file. For more info see http://www.lyx.org/
\lyxformat 544
\begin_document
\begin_header
\save_transient_properties true
\origin unavailable
\textclass article
\begin_preamble
\input{binary_c2_preamble}
\end_preamble
\use_default_options true
\maintain_unincluded_children false
\begin_local_layout

InsetLayout Flex:Command
      LyxType       Custom
      Multipar 0
      LabelString   "Command"
      LatexType     Command
      LatexName    commandwrapper
      Decoration Classic
      HTMLStyle  
	span.flex_command {
	  font-family: monospace; 
	} 
      EndHTMLStyle  

End

InsetLayout Flex:Perlscript
      LyxType       Custom
      Multipar 0
      LabelString   "Perlscript"
      LatexType     Command
      LatexName    Perlscriptwrapper
      Decoration Classic
      HTMLStyle  
	span.flex_perlscript {
	  font-style: italic; 
	} 
      EndHTMLStyle  
End

InsetLayout Flex:bashscript
      Multipar 0
      LyxType       Custom
      LabelString   "bashscript"
      LatexType     Command
      LatexName    bashscriptwrapper
      Decoration Classic
      HTMLStyle  
	span.flex_bashscript {
	  font-style: italic; 
	} 
      EndHTMLStyle  
End

InsetLayout Flex:File
      Multipar 0
      LyxType       Custom
      LabelString   "File"
      LatexType     File
      LatexName    filewrapper
      Decoration Classic
      HTMLStyle  
	span.flex_file {
	  font-style: italic; 
	} 
      EndHTMLStyle  
End

InsetLayout Flex:SourceFile
      Multipar 0
      LyxType       Custom
      LabelString   "SourceFile"
      LatexType     Command
      LatexName    sourcefilewrapper
      Decoration Classic
      HTMLStyle  
	span.flex_sourcefile {
	  font-style: italic; 
	} 
      EndHTMLStyle  
End

InsetLayout Flex:HeaderFile
      Multipar 0
      LyxType       Custom
      LabelString   "HeaderFile"
      LatexType     Command
      LatexName    headerfilewrapper
      Decoration Classic
      HTMLStyle  
	span.flex_headerfile {
	  font-style: italic; 
	} 
      EndHTMLStyle  
End

InsetLayout Flex:OS
      Multipar 0
      LyxType       Custom
      LabelString   "OS"
      LatexType     Command
      LatexName    OSwrapper
      Decoration Classic
      HTMLStyle  
	span.flex_os {
	  font-style: italic; 
	} 
      EndHTMLStyle  
End

InsetLayout Flex:CStruct
      Multipar 0
      LyxType       Custom
      LabelString   "CStruct"
      LatexType     Command
      LatexName    Cstructwrapper
      Decoration Classic
     HTMLStyle  
	span.flex_cstruct {
	  font-family: monospace; 
	} 
      EndHTMLStyle  

End

InsetLayout Flex:CFunction
      Multipar 0
      LyxType       Custom
      LabelString   "CFunction"
      LatexType     Command
      LatexName    Cfunctionwrapper
      Decoration Classic     
      HTMLStyle  
	span.flex_cfunction {
	  font-family: monospace; 
	} 
      EndHTMLStyle  

End

InsetLayout Flex:CVar
      Multipar 0
      LyxType       Custom
      LabelString   "CVar"
      LatexType     Command
      LatexName    Cvarwrapper
      Decoration Classic
      HTMLStyle  
	span.flex_cvar {
	  font-family: monospace; 
	} 
      EndHTMLStyle  

End

InsetLayout Flex:CMacro
      Multipar 0
      LyxType       Custom
      LabelString   "CMacro"
      LatexType     Command
      LatexName    Cmacrowrapper
      Decoration Classic
      HTMLTag "span"
      HTMLStyle  
	span.flex_cmacro {
	  font-family: monospace; 
	} 
      EndHTMLStyle  

End

InsetLayout Flex:FortranFunction
      Multipar 0
      LyxType       Custom
      LabelString   "FortranFunction"
      LatexType     Command
      LatexName    Fortranfunctionwrapper
      Decoration Classic
      HTMLStyle  
	span.flex_fortranfunction {
	  font-family: monospace; 
	} 
      EndHTMLStyle  

End

InsetLayout Flex:ProgrammingLanguage
      Multipar 0
      LyxType       Custom
      LabelString   "ProgrammingLanguage"
      LatexType     Command
      LatexName    ProgrammingLanguagewrapper
      Decoration Classic
      HTMLStyle  
	span.flex_programminglanguage {
	  font-style: italic; 
	} 
      EndHTMLStyle  
End

InsetLayout Flex:ScriptingLanguage
      Multipar 0
      LyxType       Custom
      LabelString   "ScriptingLanguage"
      LatexType     Command
      LatexName    ScriptingLanguagewrapper
      Decoration Classic
      HTMLStyle  
	span.flex_scriptinglanguage {
	  font-style: italic; 
	} 
      EndHTMLStyle  
End

InsetLayout Flex:Software
      Multipar 0
      LyxType       Custom
      LabelString   "Software"
      LatexType     Command
      LatexName    Softwarewrapper
      Decoration Classic
      HTMLStyle 
	font-style: italic;
      EndHTMLStyle 
      HTMLStyle  
	span.flex_software {
	  font-style: italic; 
	} 
      EndHTMLStyle  
End

InsetLayout Flex:CFlags
      Multipar 0
      LyxType       Custom
      LabelString   "CFlags"
      LatexType     Command
      LatexName    Cflagswrapper
       Decoration Classic
     HTMLStyle  
	span.flex_cflags {
	  font-family: monospace; 
	} 
      EndHTMLStyle  

End

InsetLayout Flex:Args
      Multipar 0
      LyxType       Custom
      LabelString   "Args"
      LatexType     Command
      LatexName    Argswrapper
      Decoration Classic
      HTMLStyle  
	span.flex_args {
	  font-family: monospace; 
	} 
      EndHTMLStyle  

End

InsetLayout Flex:Envvar
      Multipar 0
      LyxType       Custom
      LabelString   "Envvar"
      LatexType     Command
      LatexName    Envvarwrapper
      Decoration Classic
      HTMLStyle  
	span.flex_envvar {
	  font-family: monospace; 
	} 
      EndHTMLStyle  

End

InsetLayout Flex:Perlmodule
      Multipar 0
      LyxType       Custom
      LabelString   "Perlmodule"
      LatexType     Command
      LatexName    Perlmodulewrapper
      Decoration Classic
      HTMLStyle  
	span.flex_perlmodule {
	  font-family: monospace; 
	} 
      EndHTMLStyle  

End

InsetLayout Flex:Perlcode
      Multipar 0
      LyxType       Custom
      LabelString   "Perlcode"
      LatexType     Command
      LatexName    Perlcodewrapper
      Decoration Classic
      HTMLStyle  
	span.flex_perlcode {
	  font-family: monospace; 
	} 
      EndHTMLStyle  

End
\end_local_layout
\language british
\language_package default
\inputencoding auto
\fontencoding global
\font_roman "utopia" "default"
\font_sans "helvet" "default"
\font_typewriter "default" "default"
\font_math "auto" "auto"
\font_default_family sfdefault
\use_non_tex_fonts false
\font_sc false
\font_osf false
\font_sf_scale 100 100
\font_tt_scale 100 100
\use_microtype false
\use_dash_ligatures true
\graphics default
\default_output_format default
\output_sync 0
\bibtex_command default
\index_command default
\paperfontsize 12
\spacing single
\use_hyperref true
\pdf_bookmarks true
\pdf_bookmarksnumbered false
\pdf_bookmarksopen false
\pdf_bookmarksopenlevel 1
\pdf_breaklinks false
\pdf_pdfborder false
\pdf_colorlinks true
\pdf_backref false
\pdf_pdfusetitle true
\papersize a4paper
\use_geometry true
\use_package amsmath 1
\use_package amssymb 1
\use_package cancel 1
\use_package esint 1
\use_package mathdots 1
\use_package mathtools 1
\use_package mhchem 1
\use_package stackrel 1
\use_package stmaryrd 1
\use_package undertilde 1
\cite_engine natbib
\cite_engine_type authoryear
\biblio_style plainnat
\use_bibtopic false
\use_indices false
\paperorientation portrait
\suppress_date false
\justification true
\use_refstyle 1
\use_minted 0
\index Index
\shortcut idx
\color #008000
\end_index
\leftmargin 1.5cm
\topmargin 2cm
\rightmargin 1.5cm
\bottommargin 2cm
\secnumdepth 3
\tocdepth 3
\paragraph_separation indent
\paragraph_indentation default
\is_math_indent 0
\math_numbering_side default
\quotes_style english
\dynamic_quotes 0
\papercolumns 1
\papersides 2
\paperpagestyle fancy
\tracking_changes false
\output_changes false
\html_math_output 0
\html_css_as_file 0
\html_be_strict false
\end_header

\begin_body

\begin_layout Subsubsection
Getting the 
\begin_inset Formula $\binaryc$
\end_inset

 source code
\end_layout

\begin_layout Standard
You have a choice whether to use either 
\end_layout

\begin_layout Itemize
the latest stable release or 
\end_layout

\begin_layout Itemize
the latest version in the master branch.
\end_layout

\begin_layout Standard
The stable release is likely to contain all that you need unless you require
 some bleeding edge changes.
\end_layout

\begin_layout Description
With
\begin_inset space ~
\end_inset

git download the source code from 
\begin_inset CommandInset href
LatexCommand href
target "https://gitlab.com/binary_c/binary_c"
literal "false"

\end_inset

, e.g.
\begin_inset space ~
\end_inset

from the command line,
\begin_inset listings
inline false
status open

\begin_layout Plain Layout

git clone https://gitlab.com/binary_c/binary_c.git
\end_layout

\end_inset

or, if you have set up 
\begin_inset Flex Software
status open

\begin_layout Plain Layout
SSH
\end_layout

\end_inset

 keys on 
\begin_inset Flex Software
status open

\begin_layout Plain Layout
gitlab.com
\end_layout

\end_inset

,
\begin_inset listings
inline false
status open

\begin_layout Plain Layout

git clone git@gitlab.com:binary_c/binary_c.git
\end_layout

\end_inset

If you then want to change to the latest release, you should change to the
 appropriate branch, e.g.
\begin_inset Newline newline
\end_inset


\begin_inset listings
inline false
status open

\begin_layout Plain Layout

git checkout releases/2.2.3
\end_layout

\end_inset


\end_layout

\begin_layout Description
As
\begin_inset space ~
\end_inset

a
\begin_inset space ~
\end_inset

zip
\begin_inset space ~
\end_inset

file You should get the master if you can from 
\begin_inset Flex URL
status open

\begin_layout Plain Layout

https://gitlab.com/binary_c/binary_c/-/archive/master/binary_c-master.zip
\end_layout

\end_inset

 
\begin_inset Newline newline
\end_inset

or you can either download a release, e.g.,
\begin_inset Newline newline
\end_inset


\begin_inset Flex URL
status open

\begin_layout Plain Layout

https://gitlab.com/binary_c/binary_c/-/archive/releases/2.2.3/binary_c-releases-2.2.3.
zip
\end_layout

\end_inset


\begin_inset Newline newline
\end_inset

Note that you can change 
\begin_inset listings
inline true
status open

\begin_layout Plain Layout

.zip
\end_layout

\end_inset

 to 
\begin_inset listings
inline true
status open

\begin_layout Plain Layout

.tar.bz2
\end_layout

\end_inset

 or 
\begin_inset listings
inline true
status open

\begin_layout Plain Layout

.tar.gz
\end_layout

\end_inset

 should you prefer a different compression algorithm.
\end_layout

\begin_layout Subsubsection
Editing the source code
\end_layout

\begin_layout Standard
At present, 
\emph on
the 
\begin_inset Formula $\binaryc$
\end_inset


\emph default
 source code is accessed through gitlab.com at 
\begin_inset CommandInset href
LatexCommand href
target "https://gitlab.com/binary_c"
literal "false"

\end_inset

.
 You need a gitlab.com account to commit code.
\end_layout

\begin_layout Subsubsection
Getting the Docker image
\end_layout

\begin_layout Standard
You can access 
\emph on

\begin_inset Formula $\binaryc$
\end_inset


\emph default
 through 
\begin_inset Flex Software
status open

\begin_layout Plain Layout

\emph on
docker
\end_layout

\end_inset


\begin_inset Foot
status open

\begin_layout Plain Layout
\begin_inset CommandInset href
LatexCommand href
target "https://www.docker.com/"

\end_inset


\end_layout

\end_inset

.
 Please note that this may be outdated compared to the current version of
 
\begin_inset Formula $\binaryc$
\end_inset

 : please chase Rob if you want the 
\begin_inset Flex Software
status open

\begin_layout Plain Layout
Docker
\end_layout

\end_inset

 version updated.
\end_layout

\begin_layout Enumerate
I assume you have installed and signed in to 
\begin_inset Flex Software
status open

\begin_layout Plain Layout
docker
\end_layout

\end_inset

.
 I cannot provide support for 
\begin_inset Flex Software
status open

\begin_layout Plain Layout
Docker
\end_layout

\end_inset

!
\end_layout

\begin_layout Enumerate
The newest 
\emph on

\begin_inset Formula $\binaryc$
\end_inset


\emph default
 container should be used.
 At the time of writing this is 
\family typewriter
\series bold
robizzard/binary_c:master2.2.3
\begin_inset Newline newline
\end_inset


\series default
Public URL at Docker: 
\begin_inset CommandInset href
LatexCommand href
target "https://hub.docker.com/r/robizzard/binary_c"

\end_inset


\end_layout

\begin_layout Enumerate
Pull the 
\begin_inset Quotes eld
\end_inset

latest
\begin_inset Quotes erd
\end_inset

 version with
\begin_inset listings
lstparams "language=bash"
inline false
status open

\begin_layout Plain Layout

docker pull robizzard/binary_c
\end_layout

\end_inset

or a specific version (in this case 2.2.3) with
\begin_inset listings
lstparams "language=bash"
inline false
status open

\begin_layout Plain Layout

docker pull robizzard/binary_c:master2.2.3
\end_layout

\end_inset


\end_layout

\begin_layout Enumerate
When you run 
\begin_inset Flex Software
status open

\begin_layout Plain Layout
Docker
\end_layout

\end_inset

 it inherits your stack settings, which may be too small for binary_c to
 run.
 Use 
\begin_inset listings
lstparams "language=bash"
inline false
status open

\begin_layout Plain Layout

--ulimit stack:-1
\end_layout

\end_inset

 in your startup command to avoid this.
\end_layout

\begin_layout Enumerate
Run it with a command like
\begin_inset listings
lstparams "language=bash"
inline false
status open

\begin_layout Plain Layout

docker run --ulimit stack=-1 -it robizzard/binary_c:latest /bin/bash --login
\end_layout

\end_inset

this loads a bash shell in the directory of 
\begin_inset Formula $\binaryc$
\end_inset

.
\end_layout

\begin_layout Enumerate
Further information can be found in the file
\begin_inset Newline newline
\end_inset

 
\family typewriter

\begin_inset Flex File
status open

\begin_layout Plain Layout

\family typewriter
/home/binary_c/progs/stars/binary_c/doc/README.docker
\end_layout

\end_inset


\end_layout

\begin_layout Enumerate
The following bash script allows you to run an 
\begin_inset Flex Software
status open

\begin_layout Plain Layout
X11
\end_layout

\end_inset

-enabled terminal with 
\emph on

\begin_inset Formula $\binaryc$
\end_inset


\emph default
 and 
\emph on

\begin_inset Formula $\binarygrid$
\end_inset


\emph default
 prebuilt, you have to do nothing more than run them.
 
\begin_inset listings
lstparams "basicstyle={\footnotesize\ttfamily},breaklines=true,tabsize=4,extendedchars=true,postbreak={\mbox{\textcolor{red}{$\hookrightarrow$}\space}}"
inline false
status open

\begin_layout Plain Layout

#!/bin/bash
\end_layout

\begin_layout Plain Layout

\end_layout

\begin_layout Plain Layout

############################################################
\end_layout

\begin_layout Plain Layout

# run binary_c using docker on Linux/Unix
\end_layout

\begin_layout Plain Layout

############################################################
\end_layout

\begin_layout Plain Layout

\end_layout

\begin_layout Plain Layout

############################################################
\end_layout

\begin_layout Plain Layout

# we create a volume in binary_c_persistent : this
\end_layout

\begin_layout Plain Layout

# is a persistent file space that is stored even when
\end_layout

\begin_layout Plain Layout

# binary_c stops
\end_layout

\begin_layout Plain Layout

############################################################
\end_layout

\begin_layout Plain Layout

docker volume create binary_c_volume >/dev/null
\end_layout

\begin_layout Plain Layout

\end_layout

\begin_layout Plain Layout

############################################################
\end_layout

\begin_layout Plain Layout

# Allow connections to our X display
\end_layout

\begin_layout Plain Layout

############################################################
\end_layout

\begin_layout Plain Layout

XAUTH=$(mktemp)
\end_layout

\begin_layout Plain Layout

xauth nlist $DISPLAY |  sed -e 's/^..../ffff/' | xauth -f $XAUTH nmerge -
\end_layout

\begin_layout Plain Layout

chmod 755 $XAUTH
\end_layout

\begin_layout Plain Layout

\end_layout

\begin_layout Plain Layout

############################################################
\end_layout

\begin_layout Plain Layout

# run a bash login shell in the container : 
\end_layout

\begin_layout Plain Layout

# this leaves us in an X-connected shell.
\end_layout

\begin_layout Plain Layout

#
\end_layout

\begin_layout Plain Layout

# Note the chown/chgrp to make the persistent directory
\end_layout

\begin_layout Plain Layout

# writable by the user "binary_c"
\end_layout

\begin_layout Plain Layout

############################################################
\end_layout

\begin_layout Plain Layout

docker run 
\backslash

\end_layout

\begin_layout Plain Layout

       --name=binary_c 
\backslash

\end_layout

\begin_layout Plain Layout

       -it 
\backslash

\end_layout

\begin_layout Plain Layout

       --rm 
\backslash

\end_layout

\begin_layout Plain Layout

       -e DISPLAY=$DISPLAY 
\backslash

\end_layout

\begin_layout Plain Layout

       --ipc=host 
\backslash

\end_layout

\begin_layout Plain Layout

       --net=host 
\backslash

\end_layout

\begin_layout Plain Layout

       --mount source=binary_c_volume,target=/home/binary_c/binary_c_persistent
 
\backslash

\end_layout

\begin_layout Plain Layout

       -v /tmp/.X11-unix 
\backslash

\end_layout

\begin_layout Plain Layout

       -v $XAUTH 
\backslash

\end_layout

\begin_layout Plain Layout

       -v $HOME/.Xauthority:/home/binary_c/.Xauthority 
\backslash

\end_layout

\begin_layout Plain Layout

       robizzard/binary_c:master2.2.3 
\backslash

\end_layout

\begin_layout Plain Layout

       /bin/bash -c "sudo chown binary_c binary_c_persistent ; sudo chgrp
 binary_c binary_c_persistent; cat /home/binary_c/progs/stars/binary_c/doc/READM
E.docker; bash --login"
\end_layout

\begin_layout Plain Layout

\end_layout

\begin_layout Plain Layout

\end_layout

\begin_layout Plain Layout

\end_layout

\begin_layout Plain Layout

# to clean the BINARY_C volume run:
\end_layout

\begin_layout Plain Layout

# docker volume rm binary_c_volume
\end_layout

\begin_layout Plain Layout

\end_layout

\begin_layout Plain Layout

# clean up XAUTH
\end_layout

\begin_layout Plain Layout

rm $XAUTH
\end_layout

\end_inset


\end_layout

\end_body
\end_document
